const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const customers = sequelize.define(
    'customers',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

full_name: {
        type: DataTypes.TEXT,
      
      

      },

email: {
        type: DataTypes.TEXT,
      
      

      },

phone: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"active",


"inactive",


"blocked"

        ],

      },

preferred_contact_method: {
        type: DataTypes.TEXT,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  customers.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity








    db.customers.hasMany(db.saved_addresses, {
      as: 'saved_addresses_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });




    db.customers.hasMany(db.service_requests, {
      as: 'service_requests_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });








    db.customers.hasMany(db.payment_transactions, {
      as: 'payment_transactions_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });


    db.customers.hasMany(db.invoices, {
      as: 'invoices_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });


    db.customers.hasMany(db.subscriptions, {
      as: 'subscriptions_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });




    db.customers.hasMany(db.support_tickets, {
      as: 'support_tickets_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });










//end loop



    db.customers.belongsTo(db.organizations, {
      as: 'organization',
      foreignKey: {
        name: 'organizationId',
      },
      constraints: false,
    });

    db.customers.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });




    db.customers.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.customers.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return customers;
};


